// ICMP_sample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ICMPHelper.h"


#define		_HOST		"google.com"
#define		_RCV_TMO	1500
#define		_SND_TMO	1500
#define		_DELAY		1500
#define		_ITERAT		10

int _tmain(int argc, _TCHAR* argv[])
{
	printf( "ICMP sample\r\n(C) 2013 NAlek\r\nWEB: http://www.nalek.org\r\n-------------------------\r\n");
	CICMPHelper icmp;
	if( !icmp.InitWinSock( MAKEWORD(2, 2) ) )
		// ERROR init winsock
		printf( "Initialize WinSock ERROR\r\n" );
	else
	{
		if( icmp.OpenICMPSession( _RCV_TMO, _SND_TMO ) )
		{
			if( icmp.OpenHost( _HOST ) )
			{
				printf( "Host: %s\r\n\r\n", _HOST );
				for( int i =0; i<_ITERAT ; ++i )
				{
					int s =0, r =0;
					printf( "Send: " );
					if( icmp.SendEchoRequest( WM_USER, i, s ) ==ICMPHLP_ERR_SUCCESS )
					{
						printf( "bytes=%d.", s );

						double tmo =0.0;
						int ttl =0;
						sockaddr_in sa;

						printf( " Reply: " );
						if( icmp.ReceiveEchoReply( WM_USER, i, sa, r, tmo, ttl ) ==ICMPHLP_ERR_SUCCESS )
						{
							printf( "from: %s; bytes=%d; ttl=%d; time=%.3fms\r\n", inet_ntoa(sa.sin_addr), r, ttl, tmo );
						}
						else printf( "ERROR (%d)\r\n", ::WSAGetLastError() );
					}
					else
						printf( "ERROR (%d)\r\n", ::WSAGetLastError() );

					Sleep(_DELAY);
				}
			}
			else printf( "Host not found\r\n" );

			icmp.CloseICMPSession();
		}
		icmp.CloseWinSock();
	}
	return 0;
}

